package cc.toph.progression;

import cc.toph.progression.registry.CompatRegistry;
import cc.toph.progression.registry.ConfigRegistry;
import cc.toph.progression.registry.ItemsRegistry;
import cc.toph.progression.registry.TabRegistry;

public final class Progression {

    public static void init() {
        TabRegistry.registerTabs();
        ConfigRegistry.registerConfigs();
        ItemsRegistry.registerItems();
        CompatRegistry.registerCompats();
    }

}
