package cc.toph.progression.forge;

import cc.toph.progression.ProgressionPlatform;
import cc.toph.progression.util.Constants;
import net.minecraftforge.fml.ModList;
import net.minecraftforge.fml.loading.FMLPaths;

import java.nio.file.Path;

public class ProgressionPlatformImpl {
    /**
     * Implementation of {@link ProgressionPlatform#getConfigDirectory()}.
     */
    public static Path getConfigDirectory() {
        return FMLPaths.CONFIGDIR.get();
    }

    /**
     * Implementation of {@link ProgressionPlatform#getConfigDirectory()}.
     */
    public static String getVersion() {
        return ModList.get().getModContainerById(Constants.MOD_ID).map(it -> it.getModInfo().getVersion().toString()).orElseThrow();
    }


}