package cc.toph.progression.item.ingot;

import net.minecraft.world.entity.item.ItemEntity;
import net.minecraft.world.item.ItemStack;

public class Compound extends Ingot {

    private Ingot wannabe;

    public Compound(Properties properties, Ingot wannabe) {
        super(properties);
    }

    // Todo: Implement onEntityItemUpdate Mixin
    // Example: https://discord.com/channels/507304429255393322/507982478276034570/1329824482646429748
    // and: https://github.com/Fabricators-of-Create/Porting-Lib/blob/c42ad24ca1ecab323bfbfcb8b79e4a2c8e10bb61/modules/base/src/main/java/io/github/fabricators_of_create/porting_lib/mixin/common/ItemEntityMixin.java#L22
    public boolean onEntityItemUpdate(ItemStack stack, ItemEntity entity) {
        return false;
    }

    private void mutate(ItemStack stack, ItemEntity entity) {
        ItemStack wannabeStack = new ItemStack(wannabe);
        wannabeStack.setCount(stack.getCount());
        entity.setItem(wannabeStack);
    }

    @Override
    public Compound getItemInstance() {
        return this;
    }
}
